@ECHO OFF

REM IF "%2"=="" (SET OUTP=^&2) ELSE (SET OUTP=%2)
SET OUTP=^&2
IF "%1"=="" GOTO ERR1

SET PROG_NAME=JatheonOutlookAddIn
REM Try to find the GUID in the 32-bit WoW repository
SET PROG_GUID=
FOR /f "tokens=8 delims=\" %%i IN ('reg query HKLM\Software\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall ^| FIND "{"') DO (
  FOR /f "tokens=2,*" %%j IN ('reg query HKLM\Software\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\%%i /v DisplayName 2^>NUL') DO (
     IF "%%k" == "%PROG_NAME%" (
      SET PROG_GUID="%%i"
      GOTO GOTGUID
    )
  )
)

REM Try to find the GUID in the 64-bit repository
FOR /f "tokens=7 delims=\" %%i IN ('reg query HKLM\Software\Microsoft\Windows\CurrentVersion\Uninstall ^| FIND "{"') DO (
  FOR /f "tokens=2,*" %%j IN ('reg query HKLM\Software\Microsoft\Windows\CurrentVersion\Uninstall\%%i /v DisplayName 2^>NUL') DO (
     IF "%%k" =="%PROG_NAME%" (
      SET PROG_GUID="%%i"
      GOTO GOTGUID
    )
  )
)
GOTO ERR2
chcp 1251>nul
:GOTGUID
SET KEY_NAME_SINGLE_USER="HKEY_CURRENT_USER\SOFTWARE\Microsoft\Office\Outlook\Addins\JatheonOutlookAddIn"
SET KEY_NAME_ALL_USERS="HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Office\Outlook\Addins\JatheonOutlookAddIn"
SET FOLDER_NAME=
SET SERVER_NAME=
SET NOSSL=
SET FOLDER_VALUE="FolderName"
SET SERVER_VALUE="ServerName"
SET NOSSL_VALUE="NoSSL"

FOR /F "skip=2 tokens=2,*" %%A IN ('reg.exe query %KEY_NAME_SINGLE_USER% /v %FOLDER_VALUE% 2^>NUL') DO SET "FOLDER_NAME=%%B"
FOR /F "skip=2 tokens=2,*" %%A IN ('reg.exe query %KEY_NAME_SINGLE_USER% /v %SERVER_VALUE% 2^>NUL') DO SET "SERVER_NAME=%%B"
FOR /F "skip=2 tokens=2,*" %%A IN ('reg.exe query %KEY_NAME_SINGLE_USER% /v %NOSSL_VALUE% 2^>NUL') DO SET "NOSSL=%%B"
IF "%FOLDER_NAME%"=="" GOTO ALLUSERS
IF "%SERVER_NAME%"=="" GOTO ALLUSERS 
GOTO INSTALL

:ALLUSERS
FOR /F "skip=2 tokens=2,*" %%A IN ('reg.exe query %KEY_NAME_ALL_USERS% /v %FOLDER_VALUE% 2^>NUL') DO SET "FOLDER_NAME=%%B"
FOR /F "skip=2 tokens=2,*" %%A IN ('reg.exe query %KEY_NAME_ALL_USERS% /v %SERVER_VALUE% 2^>NUL') DO SET "SERVER_NAME=%%B"
FOR /F "skip=2 tokens=2,*" %%A IN ('reg.exe query %KEY_NAME_ALL_USERS% /v %NOSSL_VALUE% 2^>NUL') DO SET "NOSSL=%%B"
IF "%FOLDER_NAME%"=="" GOTO ERR
IF "%SERVER_NAME%"=="" GOTO ERR 

:INSTALL
SET CMD_STR=msiexec /i %1 /quiet SERVER_NAME="%SERVER_NAME%" FOLDER_NAME="%FOLDER_NAME%" NOSSL="%NOSSL%"
IF NOT "%2"=="" (SET CMD_STR=%CMD_STR% /lae+ %2)

@REM Uninstall the previous copy but only using the product code is working
ECHO Uninstall %PROG_NAME% >>%OUTP%
IF "%2"=="" (msiexec /x %PROG_GUID% /qn) ELSE  (msiexec /x %PROG_GUID% /qn /lae %2)
IF %ERRORLEVEL% NEQ 0 (
  ECHO Uninstallation failed. Cannot Update>>%OUTP% 
  EXIT /b 1
  )
@REM Install the new copy
ECHO Install new %PROG_NAME% >>%OUTP%
%CMD_STR%
IF %ERRORLEVEL% NEQ 0 (
  ECHO Installation failed. Please manually reinstall %PROG_NAME%.>>%OUTP% 
  EXIT /b 1
  )
ECHO Update %PROG_NAME% Complete.>>%OUTP%
EXIT /b

:ERR
ECHO %PROG_NAME% has not been properly installed. Please uninstall it manually and run a full install: >>%OUTP%
ECHO    msiexec /i {MSI Package} /quiet SERVER_NAME="{ServerName}" [FOLDER_NAME="{FolderName}"] [NOSSL="{True | False}"] [/lei {logfile}] >>%OUTP% 
EXIT /b 1
:ERR1
ECHO MSI Package of %PROG_NAME% is not specified. >>%OUTP%
ECHO USAGE: updatePlugin {MSI Package} [{LOG_FILE}]  >>%OUTP%
EXIT /b 1
:ERR2
ECHO %PROG_NAME% has not been installed. Please run a full install: >>%OUTP%
ECHO    msiexec /i {MSI Package} /quiet SERVER_NAME="{ServerName}" [FOLDER_NAME="{FolderName}"] [NOSSL="{True | False}"] [/lei {logfile}] >>%OUTP% 
EXIT /b 1

